/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package gproboproxy;

import java.io.*;

import ec.*;
import ec.gp.*;

import robocode.*;
import robocode.security.*;
import gprobocode.*;

/**
 * <p>Title: GPTankRunner</p>
 * <p>Description: An adapting interface between Robocode and ECJ</p>
 * <p>Universita` degli Studi di Pavia</p>
 * @author Marco Piastra
 * @version 2003-5-30
 */

public class GPTankRunner extends GPTankProxy {
    public static final String gpRobotFilename = "GPTank.ser";

    protected GPIndividual individual;
    protected GPRobocodeData data;

    public void setIndividual(GPIndividual ind) {
        individual = ind;
    }

    public GPIndividual getIndividual() {
        return individual;
    }

    public String gpRobotFilename() {
        return gpRobotFilename;
    }

    public void run() {

        // Load individual from file
        try {
            String dir =
                ((RobocodeClassLoader) getClass().getClassLoader()).getClassDirectory();
            String filename = dir + File.separator + gpRobotFilename();

            out.println("Opening file " + filename);

            InputStream in = new FileInputStream(filename);

            uploadIndividual(in);
        }
        catch (Exception e) {
            e.printStackTrace();

            throw new RuntimeException("Error while reading individual " + e);
        }

        super.run();
    }

}

